//----------------------------------------//
// d3d.h - header file for Direct3D classes/functions
//
//----------------------------------------//

//ifndef it so it doesn't get included more than once
#ifndef _D3D_H_
#define _D3D_H_

//include the files necessary for the Direct 3D stuff
#include <d3d8.h>			//main D3D8 include
#include <d3dx8.h>			//D3DX8 include
#include <D3dx8core.h>		//D3DX sprite stuff
#include <dxerr8.h>
#include "logfile.h"		//stuff for logfile
#include "enginedef.h"		//engine definitions


//the standard 3d vertex
struct CUSTOM3DVERTEX
{
    D3DXVECTOR3 position;	//vertex position
    D3DXVECTOR3 normal;		//vertex normal
	FLOAT tu, tv;		// The texture coordinates
};

//custom 3d vertex definition
#define D3DFVF_CUSTOM3DVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)


//the main Direct3D wrapper class
class D3D
{
public:

	//main D3D class variables
	LPDIRECT3D8			lpd3d;			//used to create the D3D Device
	LPDIRECT3DDEVICE8	lpd3ddevice;	//the rendering device
	int MaxSimultaneousTextures;		//max number of textures rendered in 
										//one pass
	int MaxMultisample;					//maximum anti-aliasing level
	bool HardwareVertexProcessing;		//device supports hardware vertex processing if true
	bool Windowed;						//test for windowed mode loaded from file
	int ScreenWidth;					//screen width loaded from file
	int ScreenHeight;					//screen height loaded from file
	int ColorDepth;						//color depth of the backbuffer

	//the main init and shutdown functions, constructor, destructor
	D3D();
	~D3D();

	int D3DInitialize(HWND hWnd);	//initializes Direct3D
	void D3DShutdown();				//shuts down Direct3D

};


#endif