//----------------------------------------//
// font.cpp - main file for the font and font
//		related functions
//
//----------------------------------------//

//include the header file
#include "font.h"

//--------------------------------------------------//
// Name: Font()
// Desc: fills in variables with default values
//--------------------------------------------------//
FONT::FONT()
{
	color = 0x00000000;
	font = NULL;

}

//--------------------------------------------------//
// Name: InitializeFont()
// Desc: initializes the custom font thingy
//--------------------------------------------------//
int FONT::InitializeFont(LPDIRECT3DDEVICE8 device, int size)
{
	font=new CD3DFont("Arial",			//the name of the font 
                       size,			//font size
                       D3DFONT_BOLD);	//Flags: D3DFONT_ITALIC and D3DFONT_BOLD

   //set up some of the required stuff
   font->InitDeviceObjects(device);

   //set up the rest of the objects
   font->RestoreDeviceObjects();

   //return ok
   return FONT_OK;
}

//--------------------------------------------------//
// Name: ShutdownFont()
// Desc: shuts down the custom font thingy
//--------------------------------------------------//
void FONT::ShutdownFont()
{
	//Not much to do here, just delete the object..
   if(font)
   {
      delete font;
      font=NULL;
   }
}

//--------------------------------------------------//
// Name: DrawFont()
// Desc: draws the text to the screen
//--------------------------------------------------//
int FONT::Draw(float x, float y, char text[256])
{
	 font->DrawText(x,	//X position in screen coordinates
					y,	//Y position in screen coordinates
					color,	//colour
					text);	//string to be rendered

	//must have gone ok
	return FONT_OK;
}

//--------------------------------------------------//
// Name: SetFontColor()
// Desc: sets the color of the font that is being drawn next
//--------------------------------------------------//
void FONT::SetFontColor(int alpha, int red, int green, int blue)
{
	//check to make sure the colors are within the ranges
	if(alpha > 255)
		alpha = 255;
	if(red > 255)
		red = 255;
	if(green > 255)
		green = 255;
	if(blue > 255)
		blue = 255;
		
	if(alpha < 0)
		alpha = 0;
	if(red< 0)
		red = 0;
	if(green < 0)
		green = 0;
	if(blue < 0)
		blue = 0;

	//use that nifty D3DX function
	color = D3DCOLOR_ARGB(alpha, red, green, blue);
}
