//----------------------------------------//
// gui.h - header file for GUI classes/functions
//
//----------------------------------------//

//ifndef it so it doesn't get included more than once
#ifndef _GUI_H_
#define _GUI_H_

//return types for the sprite/gui stuff
const int GUI_OK	= 0;
const int GUI_BAD	= 1;

//include the d3d stuff
#include "d3d.h"
#include "enginedef.h"

//the sprite class
class Sprite 
{
public:
	//destructor
	~Sprite();

	//variables
	LPDIRECT3DDEVICE8 Device;
	ID3DXSprite* lpd3dxsprite;
	LPDIRECT3DTEXTURE8 texture;
	CONST RECT* sourcerect;
	D3DCOLOR color;

	//the sprite functions

	//function that creates the sprite
	bool CreateSprite(LPDIRECT3DDEVICE8 device, LPCSTR filename);

	//function that draws the sprite
	void DrawSprite(D3DXVECTOR2 pos);

	//function that de-allocates all the stuff for the sprites
	void DestroySprite();

};

//the sprite vertex definition
/*struct SPRITE_CUSTOMVERTEX
{
	FLOAT x, y, z;		//Position of vertex
	DWORD colour;		//Colour of vertex
	FLOAT u, v;			//Texture coordinates
};

#define SPRITE_D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1)


//the sprite class
class Sprite
{
public:
	//constructor/destructor
	Sprite();
	~Sprite();

	//the variables
	LPDIRECT3DVERTEXBUFFER8 VertexBuffer;
	LPDIRECT3DDEVICE8 Device;
	LPDIRECT3DTEXTURE8 Tex;
	LPDIRECT3DTEXTURE8 TexOver;
	float Width;
	float Height;
	float ScreenWidth;
	float ScreenHeight;
	D3DXVECTOR2 Position;
	DWORD Color;
	bool MouseOver;

	//the functions
	int CreateSprite(LPDIRECT3DDEVICE8 device, LPCSTR texname, LPCSTR texovername, 
		float width, float height, D3DXVECTOR2 pos, float screenwidth, float screenheight);
	int RenderSprite();
	bool IsMouseOver(int x, int y);
	void DestroySprite();
	void SetSpritePosition(float x, float y);

};*/


#endif