//----------------------------------------//
// logfile.cpp - main file for error logging
//
//----------------------------------------//

//do the usual...
#include "logfile.h"

//--------------------------------------------------//
// Name: ~LOGFILE()
// Desc: destructor that closes the logfile
//--------------------------------------------------//
LOGFILE::~LOGFILE()
{
	//close the file
	outfile.close();

}

//--------------------------------------------------//
// Name: CreateLogFile()
// Desc: function that creates a file for logging 
//--------------------------------------------------//
int LOGFILE::CreateLogFile(const char* FileName)
{
	//create the file and test if it was made ok
	outfile.open(FileName);

	if(!outfile)
	{
		return LOGFILE_BAD;
	}

	//return ok
	return LOGFILE_OK;
};

//--------------------------------------------------//
// Name: LogtoFile()
// Desc: function that puts a string to the file 
//--------------------------------------------------//
int LOGFILE::LogtoFile(char OutputString[256])
{
	//output it to the file and flush it so it doesn't
	//get lost if the program messes up
	outfile<<OutputString;
	outfile.flush();

	//return ok
	return LOGFILE_OK;
}

//--------------------------------------------------//
// Name: CloseLogFile()
// Desc: closes down the logfile, if it hasn't been already.
// Note: If this function doesn't get called, the destructor will handle things
//--------------------------------------------------//
void LOGFILE::CloseLogFile()
{
	//close the file
	outfile.close();

}