//----------------------------------------//
// timer.h - header file for timer class/functions
//
//----------------------------------------//

//ifndef it so it doesn't get included more than once
#ifndef _TIMER_H_
#define _TIMER_H_

//include the necessary file for the timer
#include <windows.h>
#include <mmsystem.h>		//for timeGetTime and some other windows stuff
#include "enginedef.h"

//the defines for the timer class
const int TIMER_OK		= 0;
const int NOT_YET		= 1;
const int TIMER_BAD		= 2;


//the timer class - used for timing motion and whatnot
class TIMER
{
public:
	//variables
	LONGLONG CurrentTime;
	DWORD TimeCount;
	LONGLONG PerformanceFrequency;
	LONGLONG NextTime;
	LONGLONG PreviousTime;
	double TimeElapsed;
	double TimeScale;
	float Delta;
	int Counter;				//used in the one second timer

	//functions
	int InitTimer();
	int CheckOneSecondTimer();
	int CheckTimer();
	void UpdateTimer();

};


#endif //for _TIMER_H_